<template>
  <div>
    <h1 class="title">{{ $t('userProfile.project.showcase.homeTitle') }}</h1>

    <div class="flex justify-center items-center mb-6">
      <label
        class="ada-form-label"
        for="search-bar-query"
      >
        {{ $t('userProfile.project.showcase.search') }}
      </label>
      <input
        v-model="searchInput"
        class="ada-text-input"
        id="search-bar-query"
        type="text"
      >
      <button
        v-if="searchingProject"
        class="ada-close-search-button"
        @click="closeSearch"
        :title="$t('userProfile.project.showcase.closeSearch')"
      >
        ×
      </button>
      <div
        v-if="searchingProject"
        class="ml-5 ada-projects-found"
      >
        {{ foundProjectsSum }} {{ $t('userProfile.project.showcase.homeSearch') }}
      </div>
    </div>

    <ListProjectCard
      :projects="projectsList"
      :numberOfItems="numberOfItems"
    />
    
  </div>
</template>

<script>
import ListProjectCard from '../components/ListProjectCard.vue'

import { useAllShowcaseProjects } from '../store'
import { shuffle } from '../utils'
import { computed, watchEffect, ref } from 'vue'

export default {
  name: 'ShowcaseProjects',
  components: {
    ListProjectCard
  },
  setup () {
    const { projects: allProjects } = useAllShowcaseProjects()

    watchEffect(() => {
      shuffle(allProjects.value)
    })

    const searchInput = ref('')
    const searchingProject = computed(() => (
      searchInput.value.length > 0
    ))

    const searchProjects = (project) => {
      if (
        (project.data.name.toLowerCase().includes(searchInput.value.toLowerCase())) ||
        (project.data.abstract.toLocaleLowerCase().includes(searchInput.value.toLowerCase()))
      ) {
        return project.data.name
      } else {
        return false
      }
    }

    const closeSearch = () => {
      searchInput.value = ''
    }

    const projectsFoundOnSearch = computed(() => {
      return allProjects.value.filter(searchProjects)
    })

    const projectsList = computed(() => {
      if (searchingProject.value) {
        return projectsFoundOnSearch.value
      } else {
        return allProjects.value
      }
    })
    
    const foundProjectsSum = computed(() => (projectsFoundOnSearch.value.length))

    // Pagination params: number of items per page
    let numberOfItems = 8

    return {
      searchInput,
      searchingProject,
      closeSearch,
      projectsList,
      foundProjectsSum,
      numberOfItems
    }
  }
}
</script>

<style lang="postcss" scoped>
.title {
  @apply pb-20;
  @apply text-gray-800 text-2xl text-center;
  @apply dark:text-gray-300;
  @apply tracking-wider;
}
</style>